Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3322)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3337)
@@ -28,4 +28,7 @@
 ! -----------------
 ! $Id$
+! Add output variables usm_rad_pc_inlw, usm_rad_pc_insw*
+! 
+! 3274 2018-09-24 15:42:55Z knoop
 ! Modularization of all bulk cloud physics code components
 ! 
@@ -349,5 +352,5 @@
                spinup_pt_mean, spinup_time, time_do3d, dt_do3d,                &
                average_count_3d, varnamelength, urban_surface,                 &
-               plant_canopy
+               plant_canopy, dz
 
     USE cpulog,                                                                &
@@ -381,11 +384,11 @@
                surfinl, surfinlwdif, rad_sw_in_dir, rad_sw_in_diff,            &
                rad_lw_in_diff, surfouts, surfoutl, surfoutsl, surfoutll, surf, &
-               surfl, nsurfl, nsurfs, surfstart, pcbinsw, pcbinlw,             &
-               iup_u, inorth_u, isouth_u, ieast_u, iwest_u, iup_l,             &
+               surfl, nsurfl, pcbinsw, pcbinlw, pcbinswdir,                    &
+               pcbinswdif, iup_u, inorth_u, isouth_u, ieast_u, iwest_u, iup_l, &
                inorth_l, isouth_l, ieast_l, iwest_l, id,                       &
-               iz, iy, ix, idir, jdir, kdir,  nsurf_type, nsurf, idsvf, ndsvf, &
-               iup_a, idown_a, inorth_a, isouth_a, ieast_a, iwest_a,           &
+               iz, iy, ix,  nsurf, idsvf, ndsvf,                               &
                idcsf, ndcsf, kdcsf, pct,                                       &
-               startland, endland, startwall, endwall, skyvf, skyvft
+               startland, endland, startwall, endwall, skyvf, skyvft, nzub,    &
+               nzut, nzpt, npcbl, pcbl
 
     USE statistics,                                                            &
@@ -414,4 +417,5 @@
     INTEGER(iwp) ::  pedestrian_category = 2         !< default category for wall surface in pedestrian zone
     INTEGER(iwp) ::  roof_category = 2               !< default category for root surface
+    REAL(wp)     ::  roughness_concrete = 0.001_wp   !< roughness length of average concrete surface
 !
 !-- Indices of input attributes for (above) ground floor level 
@@ -605,4 +609,9 @@
     REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfins_av       !< average of array of residua of sw radiation absorbed in surface after last reflection
     REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfinl_av       !< average of array of residua of lw radiation absorbed in surface after last reflection
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  pcbinlw_av       !< Average of pcbinlw
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  pcbinsw_av       !< Average of pcbinsw
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  pcbinswdir_av    !< Average of pcbinswdir
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  pcbinswdif_av    !< Average of pcbinswdif
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  pcbinswref_av    !< Average of pcbinswref
     
 
@@ -1260,9 +1269,10 @@
 !--     find the real name of the variable
         ids = -1
+        l = -1
         var = TRIM(variable)
         DO i = 0, nd-1
             k = len(TRIM(var))
             j = len(TRIM(dirname(i)))
-            IF ( var(k-j+1:k) == dirname(i) )  THEN
+            IF ( TRIM(var(k-j+1:k)) == TRIM(dirname(i)) )  THEN
                 ids = i
                 idsint = dirint(ids)
@@ -1271,4 +1281,8 @@
             ENDIF
         ENDDO
+        l = idsint - 2  ! horisontal direction index - terible hack !
+        IF ( l < 0 .OR. l > 3 ) THEN
+           l = -1
+        END IF
         IF ( ids == -1 )  THEN
             var = TRIM(variable)
@@ -1311,14 +1325,13 @@
                 CASE ( 'usm_rad_net' )
 !--                 array of complete radiation balance
-                    IF ( .NOT.  ALLOCATED(surf_usm_h%rad_net_av) )  THEN
+                    IF ( l == -1 .AND. .NOT.  ALLOCATED(surf_usm_h%rad_net_av) )  THEN
                         ALLOCATE( surf_usm_h%rad_net_av(1:surf_usm_h%ns) )
                         surf_usm_h%rad_net_av = 0.0_wp
+                    ELSE
+                        IF ( .NOT.  ALLOCATED(surf_usm_v(l)%rad_net_av) )  THEN
+                            ALLOCATE( surf_usm_v(l)%rad_net_av(1:surf_usm_v(l)%ns) )
+                            surf_usm_v(l)%rad_net_av = 0.0_wp
+                        ENDIF
                     ENDIF
-                    DO  l = 0, 3
-                       IF ( .NOT.  ALLOCATED(surf_usm_v(l)%rad_net_av) )  THEN
-                           ALLOCATE( surf_usm_v(l)%rad_net_av(1:surf_usm_v(l)%ns) )
-                           surf_usm_v(l)%rad_net_av = 0.0_wp
-                       ENDIF
-                    ENDDO
                     
                 CASE ( 'usm_rad_insw' )
@@ -1398,30 +1411,63 @@
                     ENDIF
                                     
+                CASE ( 'usm_rad_pc_inlw' )
+!--                 array of of lw radiation absorbed in plant canopy
+                    IF ( .NOT.  ALLOCATED(pcbinlw_av) )  THEN
+                        ALLOCATE( pcbinlw_av(1:npcbl) )
+                        pcbinlw_av = 0.0_wp
+                    ENDIF
+                                    
+                CASE ( 'usm_rad_pc_insw' )
+!--                 array of of sw radiation absorbed in plant canopy
+                    IF ( .NOT.  ALLOCATED(pcbinsw_av) )  THEN
+                        ALLOCATE( pcbinsw_av(1:npcbl) )
+                        pcbinsw_av = 0.0_wp
+                    ENDIF
+                                    
+                CASE ( 'usm_rad_pc_inswdir' )
+!--                 array of of direct sw radiation absorbed in plant canopy
+                    IF ( .NOT.  ALLOCATED(pcbinswdir_av) )  THEN
+                        ALLOCATE( pcbinswdir_av(1:npcbl) )
+                        pcbinswdir_av = 0.0_wp
+                    ENDIF
+                                    
+                CASE ( 'usm_rad_pc_inswdif' )
+!--                 array of of diffuse sw radiation absorbed in plant canopy
+                    IF ( .NOT.  ALLOCATED(pcbinswdif_av) )  THEN
+                        ALLOCATE( pcbinswdif_av(1:npcbl) )
+                        pcbinswdif_av = 0.0_wp
+                    ENDIF
+                                    
+                CASE ( 'usm_rad_pc_inswref' )
+!--                 array of of reflected sw radiation absorbed in plant canopy
+                    IF ( .NOT.  ALLOCATED(pcbinswref_av) )  THEN
+                        ALLOCATE( pcbinswref_av(1:npcbl) )
+                        pcbinswref_av = 0.0_wp
+                    ENDIF
+                                   
                 CASE ( 'usm_rad_hf' )
 !--                 array of heat flux from radiation for surfaces after i-th reflection
-                    IF ( .NOT.  ALLOCATED(surf_usm_h%surfhf_av) )  THEN
+                    IF ( l == -1 .AND. .NOT.  ALLOCATED(surf_usm_h%surfhf_av) )  THEN
                         ALLOCATE( surf_usm_h%surfhf_av(1:surf_usm_h%ns) )
                         surf_usm_h%surfhf_av = 0.0_wp
-                    ENDIF
-                    DO  l = 0, 3
+                    ELSE
                        IF ( .NOT.  ALLOCATED(surf_usm_v(l)%surfhf_av) )  THEN
                            ALLOCATE( surf_usm_v(l)%surfhf_av(1:surf_usm_v(l)%ns) )
                            surf_usm_v(l)%surfhf_av = 0.0_wp
                        ENDIF
-                    ENDDO
+                    ENDIF
 
                 CASE ( 'usm_wshf' )
 !--                 array of sensible heat flux from surfaces
 !--                 land surfaces
-                    IF ( .NOT.  ALLOCATED(surf_usm_h%wshf_eb_av) )  THEN
+                    IF ( l == -1 .AND. .NOT.  ALLOCATED(surf_usm_h%wshf_eb_av) )  THEN
                         ALLOCATE( surf_usm_h%wshf_eb_av(1:surf_usm_h%ns) )
                         surf_usm_h%wshf_eb_av = 0.0_wp
-                    ENDIF
-                    DO  l = 0, 3
+                    ELSE
                        IF ( .NOT.  ALLOCATED(surf_usm_v(l)%wshf_eb_av) )  THEN
                            ALLOCATE( surf_usm_v(l)%wshf_eb_av(1:surf_usm_v(l)%ns) )
                            surf_usm_v(l)%wshf_eb_av = 0.0_wp
                        ENDIF
-                    ENDDO
+                    ENDIF
 !
 !--             Please note, the following output quantities belongs to the 
@@ -1431,157 +1477,145 @@
                 CASE ( 'usm_wghf' )
 !--                 array of heat flux from ground (wall, roof, land)
-                    IF ( .NOT.  ALLOCATED(surf_usm_h%wghf_eb_av) )  THEN
+                    IF ( l == -1 .AND. .NOT.  ALLOCATED(surf_usm_h%wghf_eb_av) )  THEN
                         ALLOCATE( surf_usm_h%wghf_eb_av(1:surf_usm_h%ns) )
                         surf_usm_h%wghf_eb_av = 0.0_wp
-                    ENDIF
-                    DO  l = 0, 3
+                    ELSE
                        IF ( .NOT.  ALLOCATED(surf_usm_v(l)%wghf_eb_av) )  THEN
                            ALLOCATE( surf_usm_v(l)%wghf_eb_av(1:surf_usm_v(l)%ns) )
                            surf_usm_v(l)%wghf_eb_av = 0.0_wp
                        ENDIF
-                    ENDDO
+                    ENDIF
 
                 CASE ( 'usm_wghf_window' )
 !--                 array of heat flux from window ground (wall, roof, land)
-                    IF ( .NOT.  ALLOCATED(surf_usm_h%wghf_eb_window_av) )  THEN
+                    IF ( l == -1 .AND. .NOT.  ALLOCATED(surf_usm_h%wghf_eb_window_av) )  THEN
                         ALLOCATE( surf_usm_h%wghf_eb_window_av(1:surf_usm_h%ns) )
                         surf_usm_h%wghf_eb_window_av = 0.0_wp
-                    ENDIF
-                    DO  l = 0, 3
+                    ELSE
                        IF ( .NOT.  ALLOCATED(surf_usm_v(l)%wghf_eb_window_av) )  THEN
                            ALLOCATE( surf_usm_v(l)%wghf_eb_window_av(1:surf_usm_v(l)%ns) )
                            surf_usm_v(l)%wghf_eb_window_av = 0.0_wp
                        ENDIF
-                    ENDDO
+                    ENDIF
 
                 CASE ( 'usm_wghf_green' )
 !--                 array of heat flux from green ground (wall, roof, land)
-                    IF ( .NOT.  ALLOCATED(surf_usm_h%wghf_eb_green_av) )  THEN
+                    IF ( l == -1 .AND. .NOT.  ALLOCATED(surf_usm_h%wghf_eb_green_av) )  THEN
                         ALLOCATE( surf_usm_h%wghf_eb_green_av(1:surf_usm_h%ns) )
                         surf_usm_h%wghf_eb_green_av = 0.0_wp
-                    ENDIF
-                    DO  l = 0, 3
+                    ELSE
                        IF ( .NOT.  ALLOCATED(surf_usm_v(l)%wghf_eb_green_av) )  THEN
                            ALLOCATE( surf_usm_v(l)%wghf_eb_green_av(1:surf_usm_v(l)%ns) )
                            surf_usm_v(l)%wghf_eb_green_av = 0.0_wp
                        ENDIF
-                    ENDDO
+                    ENDIF
 
                 CASE ( 'usm_iwghf' )
 !--                 array of heat flux from indoor ground (wall, roof, land)
-                    IF ( .NOT.  ALLOCATED(surf_usm_h%iwghf_eb_av) )  THEN
+                    IF ( l == -1 .AND. .NOT.  ALLOCATED(surf_usm_h%iwghf_eb_av) )  THEN
                         ALLOCATE( surf_usm_h%iwghf_eb_av(1:surf_usm_h%ns) )
                         surf_usm_h%iwghf_eb_av = 0.0_wp
-                    ENDIF
-                    DO  l = 0, 3
+                    ELSE
                        IF ( .NOT.  ALLOCATED(surf_usm_v(l)%iwghf_eb_av) )  THEN
                            ALLOCATE( surf_usm_v(l)%iwghf_eb_av(1:surf_usm_v(l)%ns) )
                            surf_usm_v(l)%iwghf_eb_av = 0.0_wp
                        ENDIF
-                    ENDDO
+                    ENDIF
 
                 CASE ( 'usm_iwghf_window' )
 !--                 array of heat flux from indoor window ground (wall, roof, land)
-                    IF ( .NOT.  ALLOCATED(surf_usm_h%iwghf_eb_window_av) )  THEN
+                    IF ( l == -1 .AND. .NOT.  ALLOCATED(surf_usm_h%iwghf_eb_window_av) )  THEN
                         ALLOCATE( surf_usm_h%iwghf_eb_window_av(1:surf_usm_h%ns) )
                         surf_usm_h%iwghf_eb_window_av = 0.0_wp
-                    ENDIF
-                    DO  l = 0, 3
+                    ELSE
                        IF ( .NOT.  ALLOCATED(surf_usm_v(l)%iwghf_eb_window_av) )  THEN
                            ALLOCATE( surf_usm_v(l)%iwghf_eb_window_av(1:surf_usm_v(l)%ns) )
                            surf_usm_v(l)%iwghf_eb_window_av = 0.0_wp
                        ENDIF
-                    ENDDO
+                    ENDIF
                     
                 CASE ( 'usm_t_surf' )
 !--                 surface temperature for surfaces
-                    IF ( .NOT.  ALLOCATED(surf_usm_h%t_surf_av) )  THEN
+                    IF ( l == -1 .AND. .NOT.  ALLOCATED(surf_usm_h%t_surf_av) )  THEN
                         ALLOCATE( surf_usm_h%t_surf_av(1:surf_usm_h%ns) )
                         surf_usm_h%t_surf_av = 0.0_wp
-                    ENDIF
-                    DO  l = 0, 3
+                    ELSE
                        IF ( .NOT.  ALLOCATED(surf_usm_v(l)%t_surf_av) )  THEN
                            ALLOCATE( surf_usm_v(l)%t_surf_av(1:surf_usm_v(l)%ns) )
                            surf_usm_v(l)%t_surf_av = 0.0_wp
                        ENDIF
-                    ENDDO
+                    ENDIF
 
                 CASE ( 'usm_t_surf_window' )
 !--                 surface temperature for window surfaces
-                    IF ( .NOT.  ALLOCATED(surf_usm_h%t_surf_window_av) )  THEN
+                    IF ( l == -1 .AND. .NOT.  ALLOCATED(surf_usm_h%t_surf_window_av) )  THEN
                         ALLOCATE( surf_usm_h%t_surf_window_av(1:surf_usm_h%ns) )
                         surf_usm_h%t_surf_window_av = 0.0_wp
-                    ENDIF
-                    DO  l = 0, 3
+                    ELSE
                        IF ( .NOT.  ALLOCATED(surf_usm_v(l)%t_surf_window_av) )  THEN
                            ALLOCATE( surf_usm_v(l)%t_surf_window_av(1:surf_usm_v(l)%ns) )
                            surf_usm_v(l)%t_surf_window_av = 0.0_wp
                        ENDIF
-                    ENDDO
+                    ENDIF
                     
                 CASE ( 'usm_t_surf_green' )
 !--                 surface temperature for green surfaces
-                    IF ( .NOT.  ALLOCATED(surf_usm_h%t_surf_green_av) )  THEN
+                    IF ( l == -1 .AND. .NOT.  ALLOCATED(surf_usm_h%t_surf_green_av) )  THEN
                         ALLOCATE( surf_usm_h%t_surf_green_av(1:surf_usm_h%ns) )
                         surf_usm_h%t_surf_green_av = 0.0_wp
-                    ENDIF
-                    DO  l = 0, 3
+                    ELSE
                        IF ( .NOT.  ALLOCATED(surf_usm_v(l)%t_surf_green_av) )  THEN
                            ALLOCATE( surf_usm_v(l)%t_surf_green_av(1:surf_usm_v(l)%ns) )
                            surf_usm_v(l)%t_surf_green_av = 0.0_wp
                        ENDIF
-                    ENDDO
+                    ENDIF
                 
                 CASE ( 'usm_t_surf_10cm' )
 !--                 near surface temperature for whole surfaces
-                    IF ( .NOT.  ALLOCATED(surf_usm_h%t_surf_10cm_av) )  THEN
+                    IF ( l == -1 .AND. .NOT.  ALLOCATED(surf_usm_h%t_surf_10cm_av) )  THEN
                         ALLOCATE( surf_usm_h%t_surf_10cm_av(1:surf_usm_h%ns) )
                         surf_usm_h%t_surf_10cm_av = 0.0_wp
-                    ENDIF
-                    DO  l = 0, 3
+                    ELSE
                        IF ( .NOT.  ALLOCATED(surf_usm_v(l)%t_surf_10cm_av) )  THEN
                            ALLOCATE( surf_usm_v(l)%t_surf_10cm_av(1:surf_usm_v(l)%ns) )
                            surf_usm_v(l)%t_surf_10cm_av = 0.0_wp
                        ENDIF
-                    ENDDO
+                    ENDIF
 
                 CASE ( 'usm_t_wall' )
 !--                 wall temperature for iwl layer of walls and land
-                    IF ( .NOT.  ALLOCATED(surf_usm_h%t_wall_av) )  THEN
+                    IF ( l == -1 .AND. .NOT.  ALLOCATED(surf_usm_h%t_wall_av) )  THEN
                         ALLOCATE( surf_usm_h%t_wall_av(nzb_wall:nzt_wall,1:surf_usm_h%ns) )
                         surf_usm_h%t_wall_av = 0.0_wp
-                    ENDIF
-                    DO  l = 0, 3
+                    ELSE
                        IF ( .NOT.  ALLOCATED(surf_usm_v(l)%t_wall_av) )  THEN
                            ALLOCATE( surf_usm_v(l)%t_wall_av(nzb_wall:nzt_wall,1:surf_usm_v(l)%ns) )
                            surf_usm_v(l)%t_wall_av = 0.0_wp
                        ENDIF
-                    ENDDO
+                    ENDIF
 
                 CASE ( 'usm_t_window' )
 !--                 window temperature for iwl layer of walls and land
-                    IF ( .NOT.  ALLOCATED(surf_usm_h%t_window_av) )  THEN
+                    IF ( l == -1 .AND. .NOT.  ALLOCATED(surf_usm_h%t_window_av) )  THEN
                         ALLOCATE( surf_usm_h%t_window_av(nzb_wall:nzt_wall,1:surf_usm_h%ns) )
                         surf_usm_h%t_window_av = 0.0_wp
-                    ENDIF
-                    DO  l = 0, 3
+                    ELSE
                        IF ( .NOT.  ALLOCATED(surf_usm_v(l)%t_window_av) )  THEN
                            ALLOCATE( surf_usm_v(l)%t_window_av(nzb_wall:nzt_wall,1:surf_usm_v(l)%ns) )
                            surf_usm_v(l)%t_window_av = 0.0_wp
                        ENDIF
-                    ENDDO
+                    ENDIF
 
                 CASE ( 'usm_t_green' )
 !--                 green temperature for iwl layer of walls and land
-                    IF ( .NOT.  ALLOCATED(surf_usm_h%t_green_av) )  THEN
+                    IF ( l == -1 .AND. .NOT.  ALLOCATED(surf_usm_h%t_green_av) )  THEN
                         ALLOCATE( surf_usm_h%t_green_av(nzb_wall:nzt_wall,1:surf_usm_h%ns) )
                         surf_usm_h%t_green_av = 0.0_wp
-                    ENDIF
-                    DO  l = 0, 3
+                    ELSE
                        IF ( .NOT.  ALLOCATED(surf_usm_v(l)%t_green_av) )  THEN
                            ALLOCATE( surf_usm_v(l)%t_green_av(nzb_wall:nzt_wall,1:surf_usm_v(l)%ns) )
                            surf_usm_v(l)%t_green_av = 0.0_wp
                        ENDIF
-                    ENDDO
+                    ENDIF
 
                CASE DEFAULT
@@ -1596,10 +1630,11 @@
                 CASE ( 'usm_rad_net' )
 !--                 array of complete radiation balance
-                    DO  m = 1, surf_usm_h%ns
-                       surf_usm_h%rad_net_av(m) =                              &
-                                          surf_usm_h%rad_net_av(m) +           &
-                                          surf_usm_h%rad_net_l(m)
-                    ENDDO
-                    DO  l = 0, 3
+                    IF ( l == -1 ) THEN
+                       DO  m = 1, surf_usm_h%ns
+                          surf_usm_h%rad_net_av(m) =                              &
+                                             surf_usm_h%rad_net_av(m) +           &
+                                             surf_usm_h%rad_net_l(m)
+                       ENDDO
+                    ELSE
                        DO  m = 1, surf_usm_v(l)%ns
                           surf_usm_v(l)%rad_net_av(m) =                        &
@@ -1607,6 +1642,6 @@
                                           surf_usm_v(l)%rad_net_l(m)
                        ENDDO
-                    ENDDO
-                    
+                    ENDIF
+
                 CASE ( 'usm_rad_insw' )
 !--                 array of sw radiation falling to surface after i-th reflection
@@ -1700,12 +1735,30 @@
                     ENDDO
                     
+                CASE ( 'usm_rad_pc_inlw' )
+                    pcbinlw_av(:) = pcbinlw_av(:) + pcbinlw(:)
+                    
+                CASE ( 'usm_rad_pc_insw' )
+                    pcbinsw_av(:) = pcbinsw_av(:) + pcbinsw(:)
+                    
+                CASE ( 'usm_rad_pc_inswdir' )
+                    pcbinswdir_av(:) = pcbinswdir_av(:) + pcbinswdir(:)
+                    
+                CASE ( 'usm_rad_pc_inswdif' )
+                    pcbinswdif_av(:) = pcbinswdif_av(:) + pcbinswdif(:)
+                    
+                CASE ( 'usm_rad_pc_inswref' )
+                    pcbinswref_av(:) = pcbinswref_av(:) + pcbinsw(:)     &
+                                                        - pcbinswdir(:)  &
+                                                        - pcbinswdif(:)
+                    
                 CASE ( 'usm_rad_hf' )
 !--                 array of heat flux from radiation for surfaces after i-th reflection
-                    DO  m = 1, surf_usm_h%ns
-                       surf_usm_h%surfhf_av(m) =                               &
-                                          surf_usm_h%surfhf_av(m) +            &
-                                          surf_usm_h%surfhf(m)
-                    ENDDO
-                    DO  l = 0, 3
+                    IF ( l == -1 ) THEN
+                       DO  m = 1, surf_usm_h%ns
+                          surf_usm_h%surfhf_av(m) =                               &
+                                             surf_usm_h%surfhf_av(m) +            &
+                                             surf_usm_h%surfhf(m)
+                       ENDDO
+                    ELSE
                        DO  m = 1, surf_usm_v(l)%ns
                           surf_usm_v(l)%surfhf_av(m) =                         &
@@ -1713,14 +1766,15 @@
                                           surf_usm_v(l)%surfhf(m)
                        ENDDO
-                    ENDDO
+                    ENDIF
                     
                 CASE ( 'usm_wshf' )
 !--                 array of sensible heat flux from surfaces (land, roof, wall)
-                    DO  m = 1, surf_usm_h%ns
-                       surf_usm_h%wshf_eb_av(m) =                              &
-                                          surf_usm_h%wshf_eb_av(m) +           &
-                                          surf_usm_h%wshf_eb(m)
-                    ENDDO
-                    DO  l = 0, 3
+                    IF ( l == -1 ) THEN
+                       DO  m = 1, surf_usm_h%ns
+                          surf_usm_h%wshf_eb_av(m) =                              &
+                                             surf_usm_h%wshf_eb_av(m) +           &
+                                             surf_usm_h%wshf_eb(m)
+                       ENDDO
+                    ELSE
                        DO  m = 1, surf_usm_v(l)%ns
                           surf_usm_v(l)%wshf_eb_av(m) =                        &
@@ -1728,14 +1782,15 @@
                                           surf_usm_v(l)%wshf_eb(m)
                        ENDDO
-                    ENDDO
+                    ENDIF
                     
                 CASE ( 'usm_wghf' )
 !--                 array of heat flux from ground (wall, roof, land)
-                    DO  m = 1, surf_usm_h%ns
-                       surf_usm_h%wghf_eb_av(m) =                              &
-                                          surf_usm_h%wghf_eb_av(m) +           &
-                                          surf_usm_h%wghf_eb(m)
-                    ENDDO
-                    DO  l = 0, 3
+                    IF ( l == -1 ) THEN
+                       DO  m = 1, surf_usm_h%ns
+                          surf_usm_h%wghf_eb_av(m) =                              &
+                                             surf_usm_h%wghf_eb_av(m) +           &
+                                             surf_usm_h%wghf_eb(m)
+                       ENDDO
+                    ELSE
                        DO  m = 1, surf_usm_v(l)%ns
                           surf_usm_v(l)%wghf_eb_av(m) =                        &
@@ -1743,14 +1798,15 @@
                                           surf_usm_v(l)%wghf_eb(m)
                        ENDDO
-                    ENDDO
+                    ENDIF
                     
                 CASE ( 'usm_wghf_window' )
 !--                 array of heat flux from window ground (wall, roof, land)
-                    DO  m = 1, surf_usm_h%ns
-                       surf_usm_h%wghf_eb_window_av(m) =                              &
-                                          surf_usm_h%wghf_eb_window_av(m) +           &
-                                          surf_usm_h%wghf_eb_window(m)
-                    ENDDO
-                    DO  l = 0, 3
+                    IF ( l == -1 ) THEN
+                       DO  m = 1, surf_usm_h%ns
+                          surf_usm_h%wghf_eb_window_av(m) =                              &
+                                             surf_usm_h%wghf_eb_window_av(m) +           &
+                                             surf_usm_h%wghf_eb_window(m)
+                       ENDDO
+                    ELSE
                        DO  m = 1, surf_usm_v(l)%ns
                           surf_usm_v(l)%wghf_eb_window_av(m) =                        &
@@ -1758,14 +1814,15 @@
                                           surf_usm_v(l)%wghf_eb_window(m)
                        ENDDO
-                    ENDDO
+                    ENDIF
 
                 CASE ( 'usm_wghf_green' )
 !--                 array of heat flux from green ground (wall, roof, land)
-                    DO  m = 1, surf_usm_h%ns
-                       surf_usm_h%wghf_eb_green_av(m) =                              &
-                                          surf_usm_h%wghf_eb_green_av(m) +           &
-                                          surf_usm_h%wghf_eb_green(m)
-                    ENDDO
-                    DO  l = 0, 3
+                    IF ( l == -1 ) THEN
+                       DO  m = 1, surf_usm_h%ns
+                          surf_usm_h%wghf_eb_green_av(m) =                              &
+                                             surf_usm_h%wghf_eb_green_av(m) +           &
+                                             surf_usm_h%wghf_eb_green(m)
+                       ENDDO
+                    ELSE
                        DO  m = 1, surf_usm_v(l)%ns
                           surf_usm_v(l)%wghf_eb_green_av(m) =                        &
@@ -1773,14 +1830,15 @@
                                           surf_usm_v(l)%wghf_eb_green(m)
                        ENDDO
-                    ENDDO
+                    ENDIF
                     
                 CASE ( 'usm_iwghf' )
 !--                 array of heat flux from indoor ground (wall, roof, land)
-                    DO  m = 1, surf_usm_h%ns
-                       surf_usm_h%iwghf_eb_av(m) =                              &
-                                          surf_usm_h%iwghf_eb_av(m) +           &
-                                          surf_usm_h%iwghf_eb(m)
-                    ENDDO
-                    DO  l = 0, 3
+                    IF ( l == -1 ) THEN
+                       DO  m = 1, surf_usm_h%ns
+                          surf_usm_h%iwghf_eb_av(m) =                              &
+                                             surf_usm_h%iwghf_eb_av(m) +           &
+                                             surf_usm_h%iwghf_eb(m)
+                       ENDDO
+                    ELSE
                        DO  m = 1, surf_usm_v(l)%ns
                           surf_usm_v(l)%iwghf_eb_av(m) =                        &
@@ -1788,14 +1846,15 @@
                                           surf_usm_v(l)%iwghf_eb(m)
                        ENDDO
-                    ENDDO
+                    ENDIF
                     
                 CASE ( 'usm_iwghf_window' )
 !--                 array of heat flux from indoor window ground (wall, roof, land)
-                    DO  m = 1, surf_usm_h%ns
-                       surf_usm_h%iwghf_eb_window_av(m) =                              &
-                                          surf_usm_h%iwghf_eb_window_av(m) +           &
-                                          surf_usm_h%iwghf_eb_window(m)
-                    ENDDO
-                    DO  l = 0, 3
+                    IF ( l == -1 ) THEN
+                       DO  m = 1, surf_usm_h%ns
+                          surf_usm_h%iwghf_eb_window_av(m) =                              &
+                                             surf_usm_h%iwghf_eb_window_av(m) +           &
+                                             surf_usm_h%iwghf_eb_window(m)
+                       ENDDO
+                    ELSE
                        DO  m = 1, surf_usm_v(l)%ns
                           surf_usm_v(l)%iwghf_eb_window_av(m) =                        &
@@ -1803,14 +1862,15 @@
                                           surf_usm_v(l)%iwghf_eb_window(m)
                        ENDDO
-                    ENDDO
+                    ENDIF
                     
                 CASE ( 'usm_t_surf' )
 !--                 surface temperature for surfaces
-                    DO  m = 1, surf_usm_h%ns
-                       surf_usm_h%t_surf_av(m) =                               & 
-                                          surf_usm_h%t_surf_av(m) +            &
-                                          t_surf_h(m)
-                    ENDDO
-                    DO  l = 0, 3
+                    IF ( l == -1 ) THEN
+                       DO  m = 1, surf_usm_h%ns
+                          surf_usm_h%t_surf_av(m) =                               &
+                                             surf_usm_h%t_surf_av(m) +            &
+                                             t_surf_h(m)
+                       ENDDO
+                    ELSE
                        DO  m = 1, surf_usm_v(l)%ns
                           surf_usm_v(l)%t_surf_av(m) =                         &
@@ -1818,14 +1878,15 @@
                                           t_surf_v(l)%t(m)
                        ENDDO
-                    ENDDO
+                    ENDIF
                     
                 CASE ( 'usm_t_surf_window' )
 !--                 surface temperature for window surfaces
-                    DO  m = 1, surf_usm_h%ns
-                       surf_usm_h%t_surf_window_av(m) =                               & 
-                                          surf_usm_h%t_surf_window_av(m) +            &
-                                          t_surf_window_h(m)
-                    ENDDO
-                    DO  l = 0, 3
+                    IF ( l == -1 ) THEN
+                       DO  m = 1, surf_usm_h%ns
+                          surf_usm_h%t_surf_window_av(m) =                               &
+                                             surf_usm_h%t_surf_window_av(m) +            &
+                                             t_surf_window_h(m)
+                       ENDDO
+                    ELSE
                        DO  m = 1, surf_usm_v(l)%ns
                           surf_usm_v(l)%t_surf_window_av(m) =                         &
